\section{Proposed Solution}
\label{sec:solution}
The solution consists of an application server that handles all the requests
made by the client devices (i.e. smartphones), and a \ac{CA}.

Initially, the client establishes a secure connection with the \ac{CA}, to
request/validate the bank's certificate. Then, the client generates an
asymmetric key pair and, after establishing a secure channel with the the bank,
sends it its public key, authenticated by a password, under the assumption the
client already has an account with the bank. The bank proceeds to send a
challenge to validate the client's public key and if the client successfully
responds to the challenge, the server generates a shared secret and sends it to
the client. This key is to be used to cipher future messages between the client
and the server. We've opted for symmetric vs. asymmetric encryption given
substantial performance improvements, resulting in less computational overhead,
meaning it's less demanding for a mobile device.

After the initial setup, the client can send transfer requests to the bank
server through \ac{SMS} (or a simulation of it), signing it with its own private
key, ciphering it with the shared secret, adding the required IV to the message,
which serves as a \textit{nonce} in order to ensure freshness, and the
signature.

Upon receiving a message, the server deciphers it with the shared key, verifies
its signature with the client's public key and either accepts it, if the
signature is valid and the message is fresh, or, otherwise, rejects it.

The messages sent by the client will have the target account's IBAN (at most 34
bytes), the amount to be transferred (limited to the thousands, i.e. 6 bytes)
and a space (1 byte), which, after being ciphered and converted to base 64, take
up to 56 bytes. The message is signed using \ac{RSA} with \ac{SHA} 256 digest,
and this signature is converted to base 64 as well, occupying 44 bytes. Since
our encryption algorithm of choice is \ac{AES} 128-bit using \ac{CTR}, there is
no need for padding, meaning no additional size (as opposed to block ciphers).
Then, the \ac{IV} (or \textit{nonce}) is concatenated (16 bytes), along with the
signature, as well as two spaces to separate the ciphertext, the \textit{nonce}
and the signature (2 bytes). This makes it so the final message size is 118
bytes long. Message format represented by \eqref{eq:sms.format.old}.
%
\begin{equation}
  \label{eq:sms.format.old}
  MESSAGE = \{IBAN||AMOUNT\}_{K_s}||NONCE||SIGNATURE
\end{equation}
%
where $||$ is a space character seperator, $K_s$ the shared secret.
\autoref{fig:comms-diagram} is a visual overview of the communication protocol
described above.

\subsection{Basic Solution}
\label{sec:solution.basic}
For the basic solution, we will focus on the core of the solution, namely
securing the communication between the server and the client (encrypting,
signing and ensuring its freshness). In this solution it is assumed that the
client and the server both have and trust each other's certificates.

\subsection{Intermediate Solution}
\label{sec:solution.intermediate}
In the intermediate solution we will introduce the \ac{CA}, meaning both the client
and the server will request each other's certificates when needed.

\subsection{Advanced Solution}
\label{sec:solution.advanced}
In the advanced solution the \ac{CA} will no longer previously have the client's
certificates, and each client will have to request a certificate to the \ac{CA},
authenticating itself with the help of the bank server.
